﻿Imports System
Imports System.IO.Ports
Imports System.Management

Public Class MainGUI

    Dim TurnNo As Integer
    Dim PitchSize As Decimal
    Dim TurnsPerLayer As Integer
    Dim NoLayers As Integer

    Dim Winding_Speed As Decimal
    Dim Winding_Width As Decimal

    Dim Feeder_StepsWidth As Decimal
    Dim Feeder_Steps As Decimal
    Dim Feeder_Speed As Decimal
    Dim Feeder_LastSteps As Integer

    Dim Dir As String

    Dim MicroStepsF As Decimal
    Dim MicroStepsW As Decimal
    Dim LeadScrew As Integer

    Dim Microstep_Combo As String
    Dim LeadScrew_Conbo As String

    Dim receivedData As String = ""
    Dim Turn_counter As String
    Dim Turn_No As Integer
    Dim Layer_counter As Byte
    Dim Layer_No As Integer

    Dim StrIndex(3) As Integer

    Private Sub Winder_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'Serial Port Setup
        SerialPort.Dispose()
        AddPort()
        com_disconnect.Enabled = False
        com_connect.Enabled = True

        'Set Default Home Radio Button
        RadioButton_Left.Checked = True

        'Disable Home Button
        Feeder_HOME.Enabled = False

        'Disable Calculate Button
        Calculate_Button.Enabled = False

        'Disble Run Button
        Run_Button.Enabled = False

        'Disable Pause Button
        Pause_Button.Enabled = False

        'Disable Cancel Button
        Cancel_Button.Enabled = False

        'Disable Home Button
        Feeder_HOME.Enabled = False

        'Winding Direction ComboBox information
        combo_direction.Items.Add("Left to Right")
        combo_direction.Items.Add("Right to Left")

        'Winding Speed ComboBox information
        Combo_Speed.Items.Add("400")
        Combo_Speed.Items.Add("600")
        Combo_Speed.Items.Add("800")
        Combo_Speed.Items.Add("1200")
        Combo_Speed.Items.Add("1400")
        Combo_Speed.Items.Add("1600")
        Combo_Speed.Items.Add("1800")
        Combo_Speed.Items.Add("2000")
        Combo_Speed.Items.Add("2200")
        Combo_Speed.Items.Add("2400")
        Combo_Speed.Items.Add("2600")
        Combo_Speed.Items.Add("2800")
        Combo_Speed.Items.Add("3000")
        Combo_Speed.SelectedIndex = Combo_Speed.FindStringExact("400")

        'Winding Information
        Turns_info.Text = ""
        Wire_Diameter_info.Text = ""
        Layers_info.Text = ""
        Width_info.Text = ""
        Speed_Info.Text = ""
        Dir_Info.Text = ""

        'Textbox Empty Alerts
        Input_Turns.BackColor = Color.white
        Input_Pitch.BackColor = Color.white
        Input_Turns_Layer.BackColor = Color.White
        Dir_Alert.BackColor = Color.LightGray

        'Disable Cut & Paste for text box
        Input_Turns.ShortcutsEnabled = False
        Input_Pitch.ShortcutsEnabled = False
        Input_Turns_Layer.ShortcutsEnabled = False

        'Microstepping Feeder
        Combo_MicroStepF.Items.Add("400")
        Combo_MicroStepF.Items.Add("4000")

        'Microstepping Winder
        Combo_MicroStepW.Items.Add("400")
        Combo_MicroStepW.Items.Add("800")
        Combo_MicroStepW.Items.Add("1600")
 
        'lead Screw Size
        Combo_LeadScrew.Items.Add("3")
        Combo_LeadScrew.Items.Add("4")
        Combo_LeadScrew.Items.Add("5")

        Combo_MicroStepF.Enabled = False
        Combo_MicroStepW.Enabled = False
        Combo_LeadScrew.Enabled = False
        Button_Save.Enabled = False
        Button_Edit.Enabled = False

        Timer.Stop()


    End Sub

    Private Sub com_connect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles com_connect.Click

        Port_Refresh.Enabled = False

        If combo_comport.SelectedItem <> "" Then

            SerialPort.BaudRate = 115200
            SerialPort.PortName = combo_comport.SelectedItem
            SerialPort.DataBits = 8
            SerialPort.Parity = Parity.None
            SerialPort.StopBits = StopBits.One
            SerialPort.Handshake = Handshake.None
            SerialPort.Encoding = System.Text.Encoding.Default
            SerialPort.ReadTimeout = 10000
            com_disconnect.Enabled = True
            com_connect.Enabled = False
            Form_Reset()
            Try
                If SerialPort.IsOpen = False Then
                    SerialPort.Open()
                    SerialPort.DtrEnable = True
                    System.Threading.Thread.Sleep(1200)
                    SerialPort.WriteLine("Z")
                    Timer.Enabled = True
                    Button_Edit.Enabled = True
                    Timer.Start()
                End If
            Catch ex As TimeoutException
                Errors.AppendText("Error: Serial Port read timed out" & vbCrLf)
            End Try
        Else
            Logs.AppendText("info: #Invalid COM Port Selected" & vbCrLf)
            com_disconnect.Enabled = False
            com_connect.Enabled = True
        End If

        Port_Refresh.Enabled = True

    End Sub

    Private Sub com_disconnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles com_disconnect.Click

        Try
            If CheckPort() = True Then
                If SerialPort.IsOpen = True Then
                    SerialPort.WriteLine("CANCEL")
                    SerialPort.Close()
                    Timer.Enabled = False
                    Pause_Button.Enabled = False
                    Cancel_Button.Enabled = False
                    Calculate_Button.Enabled = False
                    Feeder_HOME.Enabled = False
                    Logs.AppendText("info: #CNC Winder Shield Disconnected" & vbCrLf)
                    Button_Edit.Enabled = False
                    Button_Save.Enabled = False
                    Combo_MicroStepF.SelectedIndex = -1
                    Combo_MicroStepW.SelectedIndex = -1
                    Combo_LeadScrew.SelectedIndex = -1
                    Timer.Stop()
                    Form_Reset()
                End If
            Else
                System.Threading.Thread.Sleep(1200)
                Combo_MicroStepF.SelectedIndex = -1
                Combo_MicroStepW.SelectedIndex = -1
                Combo_LeadScrew.SelectedIndex = -1
                Parameter_Reset()
                SerialPort.Dispose()
            End If
        Catch ex As IO.IOException
            Errors.AppendText("Error: Serial Port read timed out" & vbCrLf)
        End Try

        Parameter_Reset()

    End Sub

    Private Sub Calculate_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Calculate_Button.Click

        Turns_info.Text = ""
        Wire_Diameter_info.Text = ""
        Layers_info.Text = ""
        Width_info.Text = ""
        Speed_Info.Text = ""
        Dir_Info.Text = ""
        Turns_Count.Text = "00000"

        Dim DecCheck As Integer
        Dim Counter As Integer

        'LeadScrew Size
        LeadScrew = CInt(Combo_LeadScrew.SelectedItem)

        Counter = Input_Pitch.Text.Count - 1
        DecCheck = 0

        'Check for additional decimal error on the pitch input
        For Counter = 1 To Input_Pitch.Text.Count
            If Input_Pitch.Text.ElementAt(Counter - 1) = "." Then
                DecCheck = DecCheck + 1
            End If
        Next

        If DecCheck = 1 Or DecCheck = 0 Then

            If Input_Turns.Text <> String.Empty And Input_Pitch.Text <> String.Empty And Input_Turns_Layer.Text <> String.Empty And combo_direction.SelectedItem <> "" Then

                If CDec(Input_Pitch.Text) <> 0 And CInt(Input_Turns.Text) <> 0 And CInt(Input_Turns_Layer.Text) <> 0 Then

                    If CDec(Input_Pitch.Text) < 1.3 Then

                        Input_Pitch.BackColor = Color.white

                        TurnNo = CInt(Input_Turns.Text)
                        PitchSize = CDec(Input_Pitch.Text)
                        TurnsPerLayer = CInt(Input_Turns_Layer.Text)
                        Winding_Speed = CDec(Combo_Speed.SelectedItem)

                        'Total Number of Layers
                        NoLayers = Fix(TurnNo / TurnsPerLayer)

                        'Calculate Width of the winding
                        Winding_Width = PitchSize * TurnsPerLayer

                        'Steps needed for winding width
                        Feeder_StepsWidth = Winding_Width * (MicroStepsF / LeadScrew)

                        'Steps per sec for feeder
                        Feeder_Speed = Math.Round((Winding_Width * (MicroStepsW / LeadScrew)) / Math.Round((TurnsPerLayer * MicroStepsW / Winding_Speed), 3), 3) * (MicroStepsF / MicroStepsW)

                        'Calculate if any out standing winding turns
                        Feeder_LastSteps = 0
                        Feeder_LastSteps = (TurnNo - (NoLayers * TurnsPerLayer)) * MicroStepsF

                        'Steps Total for Feeder Steper
                        Feeder_Steps = (Feeder_StepsWidth * NoLayers) + Feeder_LastSteps

                        If TurnsPerLayer > TurnNo Then
                            Errors.AppendText("Error: #Total Numbers of turn must not be less than number of turns per layer" & vbCrLf)
                            Run_Button.Enabled = False
                        Else

                            If SerialPort.IsOpen = False Then
                                Run_Button.Enabled = False
                            Else
                                System.Threading.Thread.Sleep(1200)
                                Run_Button.Enabled = True
                            End If

                            Turns_info.Text = TurnNo
                            Wire_Diameter_info.Text = PitchSize
                            If (TurnNo / TurnsPerLayer) > NoLayers Then
                                Layers_info.Text = NoLayers '+ 1
                            Else
                                Layers_info.Text = NoLayers
                            End If

                            Width_info.Text = Winding_Width
                            Speed_Info.Text = Winding_Speed
                            Dir = combo_direction.SelectedIndex
                            Dir_Info.Text = combo_direction.SelectedItem
                        End If
                    Else
                        Input_Pitch.BackColor = Color.Red
                        Errors.AppendText("Error: Maximum pitch size allowed is 1.2mm" & vbCrLf)
                        Run_Button.Enabled = False
                    End If
                End If
            End If
        End If

        If Input_Turns.Text = String.Empty Then
            Input_Turns.BackColor = Color.Red
            Errors.AppendText("Error: Invalid number of turns" & vbCrLf)
            Run_Button.Enabled = False
        ElseIf CInt(Input_Turns.Text) = 0 Then
            Input_Turns.BackColor = Color.Red
            Errors.AppendText("Error: Invalid number of turns" & vbCrLf)
            Run_Button.Enabled = False
        Else
            Input_Turns.BackColor = Color.White
            Input_Turns.BackColor = Color.White
        End If

        If Input_Pitch.Text = String.Empty Then
            Input_Pitch.BackColor = Color.Red
            Errors.AppendText("Error: Invalid number of pitch size" & vbCrLf)
            Run_Button.Enabled = False
        End If

        If Input_Turns_Layer.Text = String.Empty Then
            Input_Turns_Layer.BackColor = Color.Red
            Errors.AppendText("Error: Invalid number of turns per layer" & vbCrLf)
            Run_Button.Enabled = False
        ElseIf CInt(Input_Turns_Layer.Text) = 0 Then
            Input_Turns_Layer.BackColor = Color.Red
            Errors.AppendText("Error: Invalid number of turns per layer" & vbCrLf)
            Run_Button.Enabled = False
        Else
            Input_Turns_Layer.BackColor = Color.White
        End If

        If combo_direction.SelectedItem = "" Then
            Dir_Alert.BackColor = Color.Red
            Errors.AppendText("Error: Feeder directon not selected " & vbCrLf)
            Run_Button.Enabled = False
        Else
            Dir_Alert.BackColor = Color.LightGray
        End If

        Button_Edit.Enabled = True
        Button_Save.Enabled = False
        Combo_MicroStepF.Enabled = False
        Combo_MicroStepW.Enabled = False
        Combo_LeadScrew.Enabled = False

        'MsgBox(TurnNo * MicroStepsW & "," & Winding_Speed & "," & Feeder_StepsWidth & "," & Feeder_Steps & "," & Feeder_Speed & "," & NoLayers & "," & TurnsPerLayer & "," & Dir)
    End Sub

    Private Sub Run_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Run_Button.Click
        Try
            If CheckPort() = True Then
                If SerialPort.IsOpen = True Then
                    Logs.AppendText("info: #Running winding parameters" & vbCrLf)
                    SerialPort.WriteLine("RUN_CODE," & (TurnNo * MicroStepsW) & "," & Winding_Speed & "," & Feeder_StepsWidth & "," & Feeder_Steps & "," & Feeder_Speed & "," & NoLayers & "," & TurnsPerLayer & "," & Dir)
                    Run_Button.Enabled = False
                    Calculate_Button.Enabled = False
                    Feeder_HOME.Enabled = False
                    Pause_Button.Enabled = True
                    Button_Edit.Enabled = False
                    Button_Save.Enabled = False
                    Turns_Count.Text = "00000"
                End If
            Else
                Parameter_Reset()
                SerialPort.Dispose()
            End If
        Catch ex As TimeoutException
            Errors.AppendText("Error: Serial Port read timed out" & vbCrLf)
        End Try

        Button_Edit.Enabled = True
        Button_Save.Enabled = False
        Combo_MicroStepF.Enabled = False
        Combo_LeadScrew.Enabled = False

    End Sub

    Private Sub Pause_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Pause_Button.Click
        Try
            If CheckPort() = True Then
                If SerialPort.IsOpen = True Then
                    If Pause_Button.Text = "Pause" Then
                        SerialPort.WriteLine("PAUSE")
                        Pause_Button.Enabled = False
                        System.Threading.Thread.Sleep(1000)
                        Pause_Button.Enabled = True
                        Pause_Button.Text = "Resume"
                        Button_Edit.Enabled = False
                        Button_Save.Enabled = False
                    ElseIf Pause_Button.Text = "Resume" Then
                        SerialPort.WriteLine("RESUME")
                        Pause_Button.Enabled = False
                        System.Threading.Thread.Sleep(1000)
                        Pause_Button.Enabled = True
                        Pause_Button.Text = "Pause"
                        Button_Edit.Enabled = False
                        Button_Save.Enabled = False
                    End If
                End If
            Else
                Parameter_Reset()
                SerialPort.Dispose()
            End If
        Catch ex As IO.IOException
            Errors.AppendText("Error: Serial Port read timed out" & vbCrLf)
        End Try
    End Sub

    Private Sub Port_Refresh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Port_Refresh.Click
        'Serial Port Setup
        AddPort()
        Try
            If CheckPort() = True Then
                If SerialPort.IsOpen = True Then
                    combo_comport.SelectedItem = SerialPort.PortName.ToString
                End If
            Else
                Parameter_Reset()
                SerialPort.Dispose()
            End If
        Catch ex As IO.IOException
            Errors.AppendText("Error: Serial Port read timed out" & vbCrLf)
        End Try
    End Sub

    Private Sub Exit_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Exit_Button.Click
        Try
            If CheckPort() = True Then
                If SerialPort.IsOpen = True Then
                    SerialPort.WriteLine("CANCEL")
                    SerialPort.Close()
                    Timer.Enabled = False
                    Pause_Button.Enabled = False
                    Cancel_Button.Enabled = False
                End If
            Else
                Parameter_Reset()
                SerialPort.Dispose()
            End If
        Catch ex As IO.IOException
            Errors.AppendText("Error: Serial Port read timed out" & vbCrLf)
        End Try
        Me.Close()
    End Sub

    Private Sub Button_Save_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Save.Click
        Try
            If CheckPort() = True Then
                If SerialPort.IsOpen = True Then
                    If Combo_MicroStepF.SelectedItem <> "" And Combo_MicroStepW.SelectedItem <> "" And Combo_LeadScrew.SelectedItem <> "" Then
                        SerialPort.WriteLine("SAVE:" & Combo_MicroStepF.SelectedItem & ":" & Combo_MicroStepW.SelectedItem & ":" & Combo_LeadScrew.SelectedItem & ":")
                    Else
                        Errors.AppendText("Error: Unable to save configuration" & vbCrLf)
                    End If
                End If
            Else
                Parameter_Reset()
                SerialPort.Dispose()
            End If
        Catch ex As IO.IOException
            Errors.AppendText("Error: Serial Port read timed out" & vbCrLf)
        End Try

        Button_Edit.Enabled = True
        Button_Save.Enabled = False
        Combo_MicroStepF.Enabled = False
        Combo_MicroStepW.Enabled = False
        Combo_LeadScrew.Enabled = False

    End Sub

    Private Sub Button_Edit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Edit.Click

        Combo_MicroStepF.Enabled = True
        Combo_MicroStepW.Enabled = True
        Combo_LeadScrew.Enabled = True
        Button_Edit.Enabled = False
        Button_Save.Enabled = True

    End Sub

    Private Sub Feeder_HOME_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Feeder_HOME.Click
        If SerialPort.IsOpen = True Then
            Run_Button.Enabled = False
            Feeder_HOME.Enabled = False
            Calculate_Button.Enabled = False
            If RadioButton_Left.Checked = True Then
                System.Threading.Thread.Sleep(1200)
                SerialPort.WriteLine("HOME_L")
                Button_Edit.Enabled = False
                Button_Save.Enabled = False
            ElseIf RadioButton_Right.Checked = True Then
                System.Threading.Thread.Sleep(1200)
                SerialPort.WriteLine("HOME_R")
                Button_Edit.Enabled = False
                Button_Save.Enabled = False
            End If
        End If
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Try
            If CheckPort() = True Then
                If SerialPort.IsOpen = True Then
                    SerialPort.WriteLine("CANCEL")
                    Pause_Button.Text = "Pause"
                    Button_Edit.Enabled = True
                    Button_Save.Enabled = False
                    Turns_Count.Text = "00000"
                End If
            Else
                Parameter_Reset()
                SerialPort.Dispose()
            End If
        Catch ex As IO.IOException
            Errors.AppendText("Error: Serial Port read timed out" & vbCrLf)
        End Try
    End Sub

    Private Function AddPort() As Boolean
        Dim PortExist As Boolean = False
        Dim PortName As String
        Dim C1 As Integer
        Dim C2 As Integer

        combo_comport.Items.Clear()

        Try
            Dim searcher As New ManagementObjectSearcher( _
           "root\cimv2", _
           "SELECT * FROM Win32_SerialPort")

            For Each queryObj As ManagementObject In searcher.Get()
                PortName = queryObj("Name")
                C1 = InStr(PortName, "(", CompareMethod.Text) + 1
                C2 = InStr(PortName, ")", CompareMethod.Text)
                PortName = Mid(PortName, C1, C2 - C1)
                combo_comport.Items.Add(PortName)
                If SerialPort.PortName = PortName Then
                    PortExist = True
                End If
            Next

        Catch err As ManagementException
            Errors.AppendText("Error: An error occurred while querying for WMI data: " & err.Message & vbCrLf)
        End Try

        Return PortExist

    End Function

    Private Function CheckPort() As Boolean
        Dim PortExist As Boolean = False
        Dim PortName As String
        Dim C1 As Integer
        Dim C2 As Integer
        Try
            Dim searcher As New ManagementObjectSearcher( _
           "root\cimv2", _
           "SELECT * FROM Win32_SerialPort")

            For Each queryObj As ManagementObject In searcher.Get()
                PortName = queryObj("Name")
                C1 = InStr(PortName, "(", CompareMethod.Text) + 1
                C2 = InStr(PortName, ")", CompareMethod.Text)
                PortName = Mid(PortName, C1, C2 - C1)
                If SerialPort.PortName = PortName Then
                    PortExist = True
                End If
            Next

        Catch err As ManagementException
            Errors.AppendText("Error: An error occurred while querying for WMI data: " & err.Message & vbCrLf)
        End Try

        Return PortExist

    End Function

    Private Sub Timer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer.Tick

        receivedData = ReceiveSerialData()

        If receivedData <> "" Then

            If receivedData.Substring(0, 1) = "Z" Then
                If receivedData.Length > 1 Then
                    StrIndex(0) = receivedData.IndexOf(":") + 1
                    StrIndex(1) = receivedData.IndexOf(":", StrIndex(0)) + 1
                    StrIndex(2) = receivedData.IndexOf(":", StrIndex(1)) + 1
                    StrIndex(3) = receivedData.IndexOf(":", StrIndex(2)) + 1
                    MicroStepsF = CInt(receivedData.Substring(StrIndex(0), StrIndex(1) - StrIndex(0) - 1))
                    MicroStepsW = CInt(receivedData.Substring(StrIndex(1), StrIndex(2) - StrIndex(1) - 1))
                    LeadScrew = CInt(receivedData.Substring(StrIndex(2), StrIndex(3) - StrIndex(2) - 1))
                    Cancel_Button.Enabled = True
                    Calculate_Button.Enabled = True
                    Feeder_HOME.Enabled = True
                    Combo_MicroStepF.SelectedItem = CStr(MicroStepsF)
                    Combo_MicroStepW.SelectedItem = CStr(MicroStepsW)
                    Combo_LeadScrew.SelectedItem = CStr(LeadScrew)
                    Logs.AppendText("info: #CNC Winder Shield Connected" & vbCrLf)
                End If
                If Combo_MicroStepF.SelectedItem = "" Or Combo_MicroStepW.SelectedItem = "" Or Combo_LeadScrew.SelectedItem = "" Then
                    Errors.AppendText("Error: Unable to load configuration file")
                    Parameter_Reset()
                End If
            ElseIf receivedData.Substring(0, 1) = "L" Then
                If receivedData.Length > 1 Then
                    StrIndex(0) = receivedData.IndexOf(":") + 1
                    StrIndex(1) = receivedData.IndexOf(":", StrIndex(0)) + 1
                    StrIndex(2) = receivedData.IndexOf(":", StrIndex(1)) + 1
                    StrIndex(3) = receivedData.IndexOf(":", StrIndex(2)) + 1
                    MicroStepsF = CInt(receivedData.Substring(StrIndex(0), StrIndex(1) - StrIndex(0) - 1))
                    MicroStepsW = CInt(receivedData.Substring(StrIndex(1), StrIndex(2) - StrIndex(1) - 1))
                    LeadScrew = CInt(receivedData.Substring(StrIndex(2), StrIndex(3) - StrIndex(2) - 1))
                    Combo_MicroStepF.SelectedItem = CStr(MicroStepsF)
                    Combo_MicroStepW.SelectedItem = CStr(MicroStepsW)
                    Combo_LeadScrew.SelectedItem = CStr(LeadScrew)
                Else
                    Errors.AppendText("Error: Unable to load configuration file")
                    Parameter_Reset()
                End If
            ElseIf receivedData.Substring(0, 1) = "E" Then
                Parameter_Reset()
                Errors.AppendText(receivedData & vbCrLf)
            ElseIf receivedData.Substring(0, 1) = "X" Then
                Turns_Count.Text = TurnNo.ToString("D5")
                Calculate_Button.Enabled = True
                Feeder_HOME.Enabled = True
                Pause_Button.Enabled = False
                Logs.AppendText("info: #Winding sequence reached" & vbCrLf)
            ElseIf receivedData = "HOME_END" Then
                Feeder_HOME.Enabled = True
                Calculate_Button.Enabled = True
                Pause_Button.Enabled = False
                Run_Button.Enabled = False
                Button_Edit.Enabled = True
                Button_Save.Enabled = False
                Logs.AppendText("info: #Home position reached" & vbCrLf)
            ElseIf receivedData = "HOME_TOGGLE" Then
                Feeder_HOME.Enabled = True
                Calculate_Button.Enabled = True
                Pause_Button.Enabled = False
                Run_Button.Enabled = False
                Logs.AppendText("info: #Homing failed|Toggle SW to Feeder mode" & vbCrLf)
            ElseIf receivedData = "FEEDER_DISABLED" Then
                Feeder_HOME.Enabled = True
                Calculate_Button.Enabled = True
                Pause_Button.Enabled = False
                Run_Button.Enabled = False
                Logs.AppendText("info: #Feeder motor disabled" & vbCrLf)
            ElseIf receivedData = "WINDER_DISABLED" Then
                Feeder_HOME.Enabled = True
                Calculate_Button.Enabled = True
                Pause_Button.Enabled = False
                Run_Button.Enabled = False
                Logs.AppendText("info: #Winder motor disabled" & vbCrLf)
            ElseIf receivedData = "CANCEL" Then
                Feeder_HOME.Enabled = True
                Calculate_Button.Enabled = True
                Run_Button.Enabled = False
                Pause_Button.Enabled = False
                Logs.AppendText("info: #Winding sequences canceled" & vbCrLf)
            ElseIf receivedData = "ESTOP" Then
                Feeder_HOME.Enabled = True
                Calculate_Button.Enabled = True
                Run_Button.Enabled = False
                Pause_Button.Enabled = False
                Errors.AppendText("Warning: #Emergency Stop Button Enabled" & vbCrLf)
            End If
            If IsNumeric(receivedData) Then
                Turn_No = CInt(receivedData) / MicroStepsW
                Turns_Count.Text = Turn_No.ToString("D5")
            End If

        End If

    End Sub

    Function ReceiveSerialData() As String
        Dim Incoming As String = ""

        Try
            If SerialPort.IsOpen = True Then
                Incoming = SerialPort.ReadExisting()
            End If
            If Incoming Is Nothing Then
                Return "nothing" & vbCrLf
            End If
        Catch ex As TimeoutException
            Errors.AppendText("Error: Serial Port read timed out" & vbCrLf)
        End Try

        Return Incoming

    End Function

    Private Sub Input_Turns_KeyPress(ByVal sender As Object, ByVal e As KeyPressEventArgs) Handles Input_Turns.KeyPress
        If Not Char.IsNumber(e.KeyChar) AndAlso Not Char.IsControl(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub

    Private Sub Input_Pitch_KeyPress(ByVal sender As Object, ByVal e As KeyPressEventArgs) Handles Input_Pitch.KeyPress
        Dim allowedChars As String = "0123456789." & vbBack
        If allowedChars.IndexOf(e.KeyChar) = -1 Then
            e.Handled = True
        End If

    End Sub

    Private Sub Input_Layers_KeyPress(ByVal sender As Object, ByVal e As KeyPressEventArgs) Handles Input_Turns_Layer.KeyPress
        If Not Char.IsNumber(e.KeyChar) AndAlso Not Char.IsControl(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub

    Public Sub Form_Reset()
        'Winding Information
        Turns_info.Text = ""
        Wire_Diameter_info.Text = ""
        Layers_info.Text = ""
        Width_info.Text = ""
        Speed_Info.Text = ""
        Dir_Info.Text = ""

        'Textbox Empty Alerts
        Input_Turns.BackColor = Color.white
        Input_Pitch.BackColor = Color.white
        Input_Turns_Layer.BackColor = Color.White
        Dir_Alert.BackColor = Color.LightGray

        'Deselect Direction
        combo_direction.SelectedIndex = -1

        Turns_Count.Text = "00000"
    End Sub
    Public Sub Parameter_Reset()

        com_disconnect.Enabled = False
        com_connect.Enabled = True

        'Disable Calculate Button
        Calculate_Button.Enabled = False

        'Disble Run Button
        Run_Button.Enabled = False

        'Disable Pause Button
        Pause_Button.Enabled = False

        'Disable Cancel Button
        Cancel_Button.Enabled = False

        'Winding Information
        Turns_info.Text = ""
        Wire_Diameter_info.Text = ""
        Layers_info.Text = ""
        Width_info.Text = ""
        Speed_Info.Text = ""

        'Input Values
        Input_Turns.Text = ""
        Input_Pitch.Text = ""
        Input_Turns_Layer.Text = ""
        combo_direction.SelectedIndex = -1
        Combo_Speed.SelectedIndex = 0

        'Textbox Empty Alerts
        Input_Turns.BackColor = Color.white
        Input_Turns.BackColor = Color.White
        Input_Pitch.BackColor = Color.white
        Input_Turns_Layer.BackColor = Color.White
        Dir_Alert.BackColor = Color.LightGray

        'Disable Cut & Paste for text box
        Input_Turns.ShortcutsEnabled = False
        Input_Pitch.ShortcutsEnabled = False
        Input_Turns_Layer.ShortcutsEnabled = False

        Combo_MicroStepF.Enabled = False
        Combo_LeadScrew.Enabled = False
        Button_Save.Enabled = False
        Button_Edit.Enabled = False

        Turns_Count.Text = "00000"
    End Sub
End Class
